src/routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\Auth;
use App\Http\Middleware\Welcome;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


// Route::get('locale/{locale}', function ($locale){
//     Session::put('locale', $locale);
//     return redirect()->back();
// });


// Index

Route::get('/', 'EventController@index')->name('home');

// Auth Controller
/*
 * If
 * haven't Start Session
 * then
 * go to welcome
 * else /home
 */
Route::get('/welcome', 'Auth\LoginController@welcome')->name('welcome') ;

Route::get('/auth/login', 'Auth\LoginController@showLoginForm')->name('login');
Route::post('/auth/login', 'Auth\LoginController@login')->name('login');

Route::get('/verify/{token}', 'Auth\RegisterController@verify')->name('register.verify');
Route::get('/auth/sign-up', 'Auth\RegisterController@showRegisterForm')->name('signUp');
Route::post('/auth/sign-up', 'Auth\RegisterController@register')->name('signUp');



Route::get('/auth/forget-password', 'Auth\AuthController@forgetPassword')->name('forgetPassword');
Route::get('/auth/login/social-media', 'Auth\AuthController@loginSocialMedia')->name('loginSocialMedia');

// User Controller
Route::get('/profile', 'UserController@profile')->name('user.profile');
Route::get('/profile/edit', 'UserController@editProfile')->name('user.profile.edit');
Route::post('/logout', 'Auth\LoginController@logout')->name('logout');

// Event Controller

Route::get('/event/workout', 'EventController@workout')->name('event.workout');
Route::get('/event/meal', 'EventController@meal')->name('event.meal');
Route::get('/event/sleep', 'EventController@sleep')->name('event.sleep');


//Admin Panel
Route::group(
    [
        'prefix' => 'admin',
        'as' => 'admin.',
        'namespace' => 'Admin',
        'middleware' => ['admin', 'can:admin-panel'],
    ],
    function () {
        Route::resource('users', 'UsersController');
        Route::get('/index', 'DashboardController.@index');
        Route::get('users/{user}/photo/delete', 'UsersController@deletephoto')->name('users.photo.delete');
        Route::get('users/{user}/verify', 'UsersController@verify')->name('users.verify');
        Route::get('users/{user}/set/trainer', 'UsersController@setTrainer')->name('users.set.trainer');
        Route::get('users/{user}/set/user', 'UsersController@setUser')->name('users.set.user');
        Route::get('users/{user}/set/banned', 'UsersController@setBanned')->name('users.set.banned');
        Route::get('users/{user}/set/wait', 'UsersController@setWait')->name('users.set.wait');
        Route::get('/home', 'HomeController@index')->name('home');
    }
);

src/app/Models/User/AbstractBaseModel.php
<?php

namespace App\Models\User;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Collection;
use Illuminate\Database\Query\Builder as QueryBuilder;

/**
 * Class AbstractBaseModel.
 *
 * @see <https://github.com/barryvdh/laravel-ide-helper/pull/618#issuecomment-364657196> PHPDoc reason
 *
 * @method static Builder              select($columns = ['*'])
 * @method static Model|Builder        create($attributes = [])
 * @method static Builder              distinct()
 * @method static Model|Collection|static[]|static|null find($id, $columns = [])
 * @method static Model|Builder        forceCreate($attributes)
 * @method static Builder              inRandomOrder($seed = '')
 * @method static bool                 insert($query, $bindings = [])
 * @method static Builder|QueryBuilder orderBy($column, $direction = 'asc')
 * @method static Builder|QueryBuilder orderByDesc($column)
 * @method static Collection           pluck($column, $key = null)
 * @method static Model                updateOrCreate($attributes, $values = [])
 * @method static Builder              when($value, $callback, $default = null)
 * @method static Builder              where($column, $operator = null, $value = null, $boolean = 'and')
 * @method static Builder              whereIn($column, $values, $boolean = 'and', $not = false)
 * @method static Builder|static       whereNotExists($callback, $boolean = 'and')
 * @method static Builder|static       whereNotNull($column, $boolean = 'and')
 * @method static Builder              whereNull($column, $boolean = 'and', $not = false)
 * @method static Builder join($table, $first, $operator = null, $second = null, $type = 'inner', $where = false)
 */
abstract class AbstractBaseModel extends Model
{
    /**
     * The attributes that should be mutated to dates.
     *
     * @var array
     */
    protected $dates = [
        'created_at',
        'updated_at',
        'deleted_at',
    ];

    /**
     * Получить имя таблицы, связанной с моделью.
     *
     * @return string
     */
    public static function getTableName(): string
    {
        return (new static)->getTable();
    }

    /**
     * Получить имя основного поля модели.
     *
     * @return string
     */
    public static function getPrimaryKeyName(): string
    {
        return (new static)->getKeyName();
    }
}

src/app/Http/Controllers/Admin/UsersController.php
<?php

namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;
use App\Http\Requests\Admin\Users\CreateRequest;
use App\Http\Requests\Admin\Users\UpdateRequest;
use App\UseCases\Auth\RegisterService;
use App\Http\Controllers\Controller;
use App\Models\User\User;
use App\Http\Requests\Admin\UsersCreateRequest;

class UsersController extends Controller
{
    private $register;

    public function __construct(RegisterService $register)
    {
        $this->register = $register;
    }

    public function index(Request $request)
    {
        $query = User::orderByDesc('id');

        if (!empty($value = $request->get('id'))) {
            $query->where('id', $value);
        }

        if (!empty($value = $request->get('login'))) {
            $query->where('login', 'like', '%' . $value . '%');
        }

        if (!empty($value = $request->get('email'))) {
            $query->where('email', 'like', '%' . $value . '%');
        }

        if (!empty($value = $request->get('status'))) {
            $query->where('status', $value);
        }

        if (!empty($value = $request->get('role'))) {
            $query->where('role', $value);
        }

        $users = $query->paginate(20);

        $statuses = User::statusList();

        $roles = User::rolesList();

        return view('admin.users.index', compact('users', 'statuses', 'roles'));
    }


    public function create()
    {
        return view('admin.users.create');
    }


    public function store(CreateRequest $request)
    {
        $user = User::new(
            $request['name'],
            $request['email'],
            $request['password']
        );

        return redirect()->route('admin.users.show', $user);
    }


    public function show(User $user)
    {
        return view('admin.users.show', compact('user'));
    }


    public function edit(User $user)
    {
        $roles = User::rolesList();
        $status = User::statusList();

        return view('admin.users.edit', compact('user', 'roles', 'status'));
    }


    public function update(UpdateRequest $request, User $user)
    {
        $user->update($request->only(['login', 'email', 'firstname', 'lastname']));

        if ($request['role'] !== $user->role) {
            $user->changeRole($request['role']);
        }

        if ($request['status'] !== $user->status) {
            $user->changeStatus($request['status']);
        }

        return redirect()->route('admin.users.show', $user);
    }

    public function all(Request $request)
    {
        $query = User::orderByDesc('id');

        if (!empty($value = $request->get('id'))) {
            $query->where('id', $value);
        }

        if (!empty($value = $request->get('login'))) {
            $query->where('login', 'like', '%' . $value . '%');
        }

        if (!empty($value = $request->get('email'))) {
            $query->where('email', 'like', '%' . $value . '%');
        }

        if (!empty($value = $request->get('status'))) {
            $query->where('status', $value);
        }

        if (!empty($value = $request->get('role'))) {
            $query->where('role', $value);
        }

        $users = $query->paginate(20);

        $statuses = User::statusList();

        $roles = User::rolesList();

        return view('admin.users.index', compact('users', 'statuses', 'roles'));
    }


    public function deletephoto(Request $request, User $user)
    {
        $photo_orignal = '';
        $user->setPhoto($request[$photo_orignal]);
        return redirect()->route('admin.users.show', $user);
    }


    public function destroy($id)
    {

    }

    public function verify(User $user)
    {
        $this->register->verify($user->id);

        return redirect()->route('admin.users.show', $user);
    }

    public function setTrainer(User $user)
    {
        $user->setRoleTrainer();
        return redirect()->route('admin.users.show', $user);
    }

    public function setUser(User $user)
    {
        $user->setRoleUser();
        return redirect()->route('admin.users.show', $user);
    }

    public function setBanned(User $user)
    {
        $user->setStatusBanned();
        return redirect()->route('admin.users.show', $user);
    }

    public function setWait(User $user)
    {
        $user->setStatusWait();
        return redirect()->route('admin.users.show', $user);
    }
}

src/app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class UserController extends AbstractController
{
    public function profile()
    {
        return view('user.profile');
    }

    public function editProfile()
    {
        return view('user.edit');
    }

    public function logout()
    {

    }
}

src/resources/views/admin/users/create.blade.php
@extends('layouts.admin')

@section('content')

    <form method="POST" action="{{ route('admin.users.store') }}">
        @csrf

        <div class="form-group">
            <label for="login" class="col-form-label">Login</label>
            <input id="login" class="form-control{{ $errors->has('login') ? ' is-invalid' : '' }}" name="login" value="{{ old('login') }}" required>
            @if ($errors->has('login'))
                <span class="invalid-feedback"><strong>{{ $errors->first('login') }}</strong></span>
            @endif
        </div>

        <div class="form-group">
            <label for="email" class="col-form-label">E-Mail Address</label>
            <input id="email" type="email" class="form-control{{ $errors->has('email') ? ' is-invalid' : '' }}" name="email" value="{{ old('email') }}" required>
            @if ($errors->has('email'))
                <span class="invalid-feedback"><strong>{{ $errors->first('email') }}</strong></span>
            @endif
        </div>

        <div class="form-group">
          <label for="password" class="col-form-label">Password</label>
          <input id="password" type="password" class="form-control{{ $errors->has('password') ? ' is-invalid' : '' }}" name="password" value="{{ old('password') }}" required>
          @if ($errors->has('password'))
              <span class="invalid-feedback"><strong>{{ $errors->first('password') }}</strong></span>
          @endif
      </div>

        <div class="form-group">
            <button type="submit" class="btn btn-primary">Save</button>
        </div>
    </form>
@endsection

src/resources/views/admin/users/index.blade.php
@extends('layouts.admin')

@section('content')

<p><a href="{{ route('admin.users.create') }}" class="btn btn-success mb-2">Добавить нового</a></p>

<div class="card">
    <div class="card-header">Список всех пользователей</div>
    <table class="table card-table table-hover">
        <div class="container-fluid flex-grow-1 container-p-y">
            <form action="?" method="GET">
                <div class="row">
                    <div class="col-sm-1">
                        <div class="form-group">
                            <label for="id" class="col-form-label">ID</label>
                            <input id="id" class="form-control" name="id" value="{{ request('id') }}">
                        </div>
                    </div>
                    <div class="col-sm-2">
                        <div class="form-group">
                            <label for="name" class="col-form-label">Login</label>
                            <input id="name" class="form-control" name="login" value="{{ request('login') }}">
                        </div>
                    </div>
                    <div class="col-sm-3">
                        <div class="form-group">
                            <label for="email" class="col-form-label">Email</label>
                            <input id="email" class="form-control" name="email" value="{{ request('email') }}">
                        </div>
                    </div>
                    <div class="col-sm-2">
                        <div class="form-group">
                            <label for="status" class="col-form-label">Status</label>
                            <select id="status" class="form-control" name="status">
                                <option value=""></option>
                                @foreach ($statuses as $value => $label)
                                    <option value="{{ $value }}"{{ $value === request('status') ? ' selected' : '' }}>{{ $label }}</option>
                                @endforeach;
                            </select>
                        </div>
                    </div>
                    <div class="col-sm-2">
                        <div class="form-group">
                            <label for="role" class="col-form-label">Role</label>
                            <select id="role" class="form-control" name="role">
                                <option value=""></option>
                                @foreach ($roles as $value => $label)
                                    <option value="{{ $value }}"{{ $value === request('role') ? ' selected' : '' }}>{{ $label }}</option>
                                @endforeach;
                            </select>
                        </div>
                    </div>
                    <div class="col-sm-2">
                        <div class="form-group">
                            <label class="col-form-label">&nbsp;</label><br />
                            <button type="submit" class="btn btn-primary">Search</button>
                        </div>
                    </div>
                </div>
            </form>
        </div>

        <thead class="thead-light">
            <tr>
                <th>ID</th>
                <th>User</th>
                <th>Email</th>
                <th>Status</th>
                <th>Actions</th>
            </tr>
            </thead>
            <tbody>

            @foreach ($users as $user)
                <tr>
                    <th scope="row">
                        <div class="media align-items-center p-2">
                          {{ $user->id }}
                        </div>
                    </th>

                      <td>
                        <a href="{{ route('admin.users.show', $user) }}" style="color:#212529">

                          <div class="media align-items-center pb-1">
                              @if ($user->noPhoto())
                                <img src="{{ URL::asset('/img/no-avatar.jpg') }}" class="ui-w-40 rounded-circle" alt="">
                              @else
                                <img src="{{ URL::asset( $user->photo_original ) }}" class="ui-w-40 rounded-circle" alt="">
                              @endif
                              <div class="media-body ml-3">
                                  <a href="{{ route('admin.users.show', $user) }}" class="text-dark">{{ $user->firstname }} {{ $user->lastname }}</a>
                                  <div class="text-muted small">@ {{ $user->login }}</div>
                              </div>
                              @if ($user->isAdmin())
                                <a href="users?role=admin" class="btn btn-sm btn-success d-block"><span class="fa fa-user-astronaut"></span> Администратор</a>
                              @endif
                              @if ($user->isModer())
                                <a href="users?role=moder" class="btn btn-sm btn-warning d-block"><span class="ion ion-logo-octocat"></span> Модератор</a>
                              @endif
                              @if ($user->isTrainer())
                                <a href="users?role=trainer" class="btn btn-sm btn-info d-block"><span class="ion ion-md-fitness"></span>  Тренер</a>
                              @endif
                          </div>




                      </a>
                      </td>
                    <td>
                      <div class="media align-items-center p-2">
                        {{ $user->email }}
                      </div>
                    </td>
                    <td>
                      <div class="media align-items-center p-2">
                        @if ($user->isWait())
                            <a href="users?status=wait" class="btn btn-sm btn-secondary"><span class="fa fas fa-clock"></span> Waiting</a>
                        @endif
                        @if ($user->isBanned())
                            <a href="users?status=banned" class="btn btn-sm btn-danger"><span class="fa fas fa-user-slash"></span> Banned</a>
                        @endif
                      </div>
                    </td>
                    <td class="text-center text-nowrap">
                      <div class="media align-items-center p-2">
                        <a href="{{ route('admin.users.edit', $user) }}" class="btn btn-default btn-xs icon-btn md-btn-flat user-tooltip" title="" data-original-title="Edit">
                          <i class="ion ion-md-create"></i>
                        </a>&nbsp;&nbsp;
                        <div class="btn-group">
                          <button type="button" class="btn btn-default btn-xs icon-btn md-btn-flat dropdown-toggle hide-arrow user-tooltip" title="" data-toggle="dropdown" data-original-title="Actions">
                            <i class="ion ion-ios-settings"></i>
                          </button>
                          <div class="dropdown-menu dropdown-menu-right">
                            <a class="dropdown-item" href="{{ route('admin.users.show', $user) }}">View profile</a>
                            <a class="dropdown-item" href="javascript:void(0)">Ban user</a>
                            <a class="dropdown-item" href="javascript:void(0)">Remove</a>
                          </div>
                        </div>
                      </div>
                    </td>
                </tr>
            @endforeach

        </tbody>

        {{ $users->links() }}

    </table>
</div>
<br><br>

@endsection

src/resources/views/admin/users/show.blade.php
@extends('layouts.admin')

@section('content')

<div class="media align-items-center py-3 mb-3">
    @if ($user->noPhoto())
    <img src="{{ URL::asset('/img/no-avatar.jpg') }}" class="d-block ui-w-100 rounded-circle ticket-assignee" alt="" title="" data-original-title="{{ $user->login }}">
    @else
      <img src="{{ URL::asset( $user->photo_original ) }}" class="d-block ui-w-100 rounded-circle ticket-assignee" alt="" title="" data-original-title="{{ $user->login }}">
    @endif
    <div class="media-body ml-4">
        <h4 class="font-weight-bold mb-0">{{ $user->firstname }} {{ $user->lastname }}<span class="text-muted font-weight-normal"> {{ '@'.$user->login }}</span></h4>
        <div class="text-muted mb-2">ID: {{ $user->id }}</div>
        <a href="{{ route('admin.users.edit', $user) }}" class="btn btn-primary btn-sm">Изменить</a>&nbsp;
        <div class="btn-group">
            <button class="btn btn-default btn-sm dropdown-toggle" type="button" data-toggle="dropdown"> <span>Настройки</span>&nbsp;</button>
            <div class="dropdown-menu">

                @if ($user->isUser())
                  <a href="{{ route('admin.users.set.trainer', $user) }}" class="dropdown-item text-primary">
                    <i class="ion ion-md-fitness"></i> &nbsp; Сделать тренером
                  </a>
                @endif

                @if ($user->isTrainer())
                  <a href="{{ route('admin.users.set.user', $user) }}" class="dropdown-item text-primary">
                    <i class="feather icon-user"></i> &nbsp; Сделать пользователем
                  </a>
                @endif

                @if ($user->isWait())
                <a href="{{ route('admin.users.verify', $user) }}" class="dropdown-item text-success">
                    <i class="feather icon-check-square text-success"></i> &nbsp; Verify</a>
                @endif

                @if (!$user->noPhoto())
                  <div class="dropdown-divider"></div>
                  <a class="dropdown-item" href="{{ route('admin.users.photo.delete', $user) }}">
                      <i class="feather icon-image text-danger"></i> &nbsp; {{ __('Удалить фото') }}
                  </a>
                @endif

                @if ($user->isBanned())
                  <div class="dropdown-divider"></div>
                  <a class="dropdown-item" href="{{ route('admin.users.set.wait', $user) }}">
                      <i class="feather icon-user-x text-success"></i> &nbsp; {{ __('Разблокировать') }}
                  </a>
                @endif

                @if ($user->isActive())
                  <div class="dropdown-divider"></div>
                  <a class="dropdown-item" href="{{ route('admin.users.set.banned', $user) }}">
                      <i class="feather icon-user-x text-danger"></i> &nbsp; {{ __('Заблокировать') }}
                  </a>

                  <div class="dropdown-divider"></div>
                  <a class="dropdown-item" href="{{ route('admin.users.destroy', $user) }}">
                      <i class="feather icon-x-circle text-danger"></i> &nbsp; {{ __('Удалить') }}
                  </a>
                @endif
            </div>
        </div>&nbsp;
        <a href="javascript:void(0)" class="btn btn-default btn-sm icon-btn">
            <i class="ion ion-md-mail"></i>
        </a>
    </div>
</div>

<div class="card mb-4">
    <div class="card-body">
        <table class="table user-view-table m-0">
            <tbody>
                <tr>
                    <td>Email:</td>
                    <td>{{ $user->email }}</td>
                </tr>
                <tr>
                    <td>Регистрация:</td>
                    <td>{{ date('d.m.Y', strtotime($user->created_at)) }}</td>
                </tr>
                <tr>
                    <td>Активность:</td>
                    <td>{{ $user->updated_at->diffForHumans() }}</td>
                </tr>
                <tr>
                    <td>Verified:</td>
                    <td>
                        @if ($user->isWait())
                            <span class="ion ion-md-time text-primary"></span>&nbsp; No Verify
                        @else
                          <span class="ion ion-md-checkmark text-primary"></span>&nbsp; Yes
                        @endif
                    </td>
                </tr>
                <tr>
                    <td>Роль:</td>
                    <td>
                        @if ($user->isAdmin())
                            <span class="badge badge-success">Администратор</span>
                        @endif
                        @if ($user->isModer())
                            <span class="badge badge-warning">Модератор</span>
                        @endif
                        @if ($user->isTrainer())
                            <span class="badge badge-info">Тренер</span>
                        @endif
                        @if ($user->isUser())
                            <span class="badge badge-secondary">Пользователь</span>
                        @endif
                    </td>
                </tr>
                <tr>
                    <td>Статус:</td>
                    <td>
                        @if ($user->isWait())
                            <span class="badge badge-outline-secondary">Waiting</span>
                        @endif
                        @if ($user->isActive())
                            <span class="badge badge-outline-success">Active</span>
                        @endif
                        @if ($user->isBanned())
                            <span class="badge badge-outline-danger">Banned</span>
                        @endif
                    </td>
                </tr>
            </tbody>
        </table>
    </div>
</div>

<div class="card">
    <div class="row no-gutters row-bordered">
        <div class="d-flex col-md align-items-center">
            <a href="javascript:void(0)" class="card-body d-block text-dark">
                <div class="text-muted small line-height-1">Упражнений использует</div>
                <div class="text-xlarge">125</div>
            </a>
        </div>
        <div class="d-flex col-md align-items-center">
            <a href="javascript:void(0)" class="card-body d-block text-dark">
                <div class="text-muted small line-height-1">Тренировок использует</div>
                <div class="text-xlarge">24</div>
            </a>
        </div>
        <div class="d-flex col-md align-items-center">
            <a href="javascript:void(0)" class="card-body d-block text-dark">
                <div class="text-muted small line-height-1">Подписчиков</div>
                <div class="text-xlarge">306</div>
            </a>
        </div>
    </div>
    <hr class="border-light m-0">
    <div class="card-body">
        <div class="table-responsive">
            <table class="table user-view-table m-0">
                <tbody>
                    <tr>
                        <td>Логин:</td>
                        <td>{{ $user->login }}</td>
                    </tr>
                    <tr>
                        <td>Имя Фамилия:</td>
                        <td>{{ $user->firstname }} {{ $user->lastname }}</td>
                    </tr>
                    <tr>
                        <td>E-mail:</td>
                        <td>{{ $user->email }}</td>
                    </tr>
                </tbody>
            </table>
        </div>
        <h6 class="mt-4 mb-3">Social links</h6>
        <div class="table-responsive">
            <table class="table user-view-table m-0">
                <tbody>
                    <tr>
                        <td>Twitter:</td>
                        <td>
                            <a href="javascript:void(0)">https://twitter.com/user</a>
                        </td>
                    </tr>
                    <tr>
                        <td>Facebook:</td>
                        <td>
                            <a href="javascript:void(0)">https://www.facebook.com/user</a>
                        </td>
                    </tr>
                    <tr>
                        <td>Instagram:</td>
                        <td>
                            <a href="javascript:void(0)">https://www.instagram.com/user</a>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
        <h6 class="mt-4 mb-3">Personal info</h6>
        <div class="table-responsive">
            <table class="table user-view-table m-0">
                <tbody>
                    <tr>
                        <td>Birthday:</td>
                        <td>May 3, 1995</td>
                    </tr>
                    <tr>
                        <td>Country:</td>
                        <td>Canada</td>
                    </tr>
                    <tr>
                        <td>Languages:</td>
                        <td>English</td>
                    </tr>
                </tbody>
            </table>
        </div>
        <h6 class="mt-4 mb-3">Contacts</h6>
        <div class="table-responsive">
            <table class="table user-view-table m-0">
                <tbody>
                    <tr>
                        <td>Phone:</td>
                        <td>+0 (123) 456 7891</td>
                    </tr>
                </tbody>
            </table>
        </div>
        <h6 class="mt-4 mb-3">Interests</h6>
        <div class="table-responsive">
            <table class="table user-view-table m-0">
                <tbody>
                    <tr>
                        <td>Favorite music:</td>
                        <td>
                            Rock, Alternative, Electro, Drum &amp; Bass, Dance
                        </td>
                    </tr>
                    <tr>
                        <td>Favorite movies:</td>
                        <td>
                            The Green Mile, Pulp Fiction, Back to the Future, WALL·E, Django Unchained
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
    </div>
</div>

@endsection